unit Adc16fm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Start: TButton;
    Stop: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Timer1: TTimer;
    Label6: TLabel;
    procedure StartClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  port : integer = 2;
  Opened : Boolean = FALSE;
  Started : Boolean = FALSE;

var
  Form1: TForm1;

implementation
{$I ADC16.INC}
{$R *.DFM}

procedure TForm1.StartClick(Sender: TObject);
var
  ok : boolean;
  s  : string;

begin
  if not opened then
    begin
      str (port, s);
      Label6.caption := 'Opening ADC16 on COM' + s;
      Refresh;
      opened := adc16_open_unit (port);
      if opened then
        begin
          ok := adc16_set_channel (port, 1, 16, 1, 10);
          ok := adc16_set_channel (port, 2, 16, 1, 10);
          Label6.caption := 'Running';
        end
      else
        begin
          Label6.caption := 'Unable to open ADC16';
        end
    end
end;

procedure TForm1.StopClick(Sender: TObject);
begin
if opened then
  begin
    adc16_close_unit (port);
    opened := FALSE;
    Label6.caption := 'Stopped';
  end;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  s       : string [10];
  ok      : boolean;
  value   : longint;
  volts   : real;
begin

if opened then
  begin
    ok := adc16_get_value (value, port, 1);
    if ok then
      begin
        volts := (value *2.5) / 65536;
        str (volts: 7:4, s);
        Label4.Caption := s
      end
    else
      Label4.Caption := '******';

    ok := adc16_get_value (value, port, 2);
    if ok then
      begin
        volts := (value *2.5) / 65536;
        str (volts: 7:4, s);
        Label5.Caption := s
      end
    else
      Label5.Caption := '******';
  end;
end;

end.
