/**
 * Copyright (c) 1999, 2000 Gatespace AB. All Rights Reserved.
 * 
 */

package com.gatespace.service.adc.impl;

import com.gatespace.service.adc.*;

/**
 * Test class for an ADCService.
 *
 * Prints som info on the service and registers
 * as listener to channels 0.
 * <p>
 * Source to <a href="ADCTester.java">ADCTester.java</a><br>
 */
public class ADCTester implements ChannelListener {
  
  /**
   * Test a give ADCService by adding listeners and printing
   * all values.
   *
   * @version  $Revision: 1.5 $
   */
  void test(ADCService adc) {
    
    Channel [] ch = adc.getChannels();
    
    log("Testing ADC");
    log(" type:          " + adc.getType());
    log(" version:       " + adc.getVersion());
    log(" # of channels: " + ch.length);

    // Turn on some channels and add myself as listener
    for(int i = 0; i < ch.length; i++) {
      ch[i].setActive(i == 0);
      ch[i].addChannelListener(this);
    }
  }

  // From ChannelListener interface
  public void valueChanged(Channel c) {
    // Got a new value from channel - print it
    log(c.toString());
  }

  void log(String s) {
    System.out.println(s);
  }
}
    
